import socket
import socketserver
import threading
import time


class ThreadedTCPRequestHandler(socketserver.BaseRequestHandler):

    all_requests = []

    def handle(self):
        self.all_requests.append(self.request)

        while True:
            data = self.request.recv(1024)  # oh-oh, y el concepto de "linea"?
            if not data:
                break
            for r in self.all_requests:
                if r is not self.request:
                    r.sendall(data)

        self.all_requests.remove(self.request)


class ThreadedTCPServer(socketserver.ThreadingMixIn, socketserver.TCPServer):

    def server_bind(self):
        self.socket.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)

        while True:
            try:
                self.socket.bind(self.server_address)
            except socket.error as e:
                if e[0] != 98:  # Address already in use
                    raise
                print("port is taken, trying again in a while...")
                time.sleep(2)
            else:
                break


server = ThreadedTCPServer(("localhost", 4567), ThreadedTCPRequestHandler)
server_thread = threading.Thread(target=server.serve_forever)
server_thread.start()
